package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunBuildProject extends BasicDO {
    /**
     * 表名
     */
    public static final String SCHEMA_CODE = "D00178955900d6e8f104217b7ff8f7d36b34de1";

    /**
     * 项目编号
     */
    @JsonProperty(value = "F0000003")
    private String projectCode;

    /**
     * 项目名称
     */
    @JsonProperty(value = "F0000004")
    private String projectName;

    /**
     * 签约公司
     */
    @JsonProperty(value = "F0000051")
    private String signingCompany;

    /**
     * 客户名称
     */
    @JsonProperty(value = "F0000039")
    private String customerName;
    /**
     * 业主名称
     */
    @JsonProperty(value = "F0000040")
    private String nameOfOwner;

    /**
     * 项目类型
     */
    @JsonProperty("F0000016")
    private String projectType;

    /**
     * 项目经理
     */
    @JsonProperty(value = "F0000037")
    private String projectManager;

    /**
     * 销售负责人
     */
    @JsonProperty(value = "F0000011")
    private String SalesDirector;

    /**
     * 系统免费维保期
     */
    @JsonProperty(value = "F0000104")
    private Integer systemWarranty;

    /**
     * 设备免费维保期
     */
    @JsonProperty(value = "F0000105")
    private Integer deviceWarranty;

    /**
     * 维保交付子表
     */
    @JsonProperty(value = "D001789F28649f6f044a4224b5c68aa821918f50")
    private List<ChuanyunMaintenanceProDO> maintenanceProList;

    /**
     * 维保周期子表
     */
    @JsonProperty(value = "D001789F3ffb030bffbf45a78c830cd7da9d59c9")
    private List<ChuanyunMaintenanceCycleDO> maintenanceCycleList;
}
