package com.galaxis.manatee.service.impl;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunBuildProject;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizReturnData;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.service.BuildProjectService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;

@Slf4j
@Service
public class BuildProjectServiceImpl implements BuildProjectService {

    @Autowired
    private ChuanYunManager chuanYunManager;

    @Override
    public List<ChuanyunBuildProject> findAllByProjectCode(String projectCode) {
        //从氚云查询数据
        List<String> m = List.of("status_2,1", "F0000007_2," + projectCode);
        var filter = Filter.instance(0, 10, true, Filter.AND, m);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunBuildProject.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (!Objects.isNull(chuanyunFindAllResponse)) {
            ChuanyunFindAllBizReturnData<Object> returnData = chuanyunFindAllResponse.getReturnData();
            if (chuanyunFindAllResponse.getSuccessful() && !Objects.isNull(returnData)) {
                Object bizObject = returnData.getBizObjectArray();
                ObjectMapper objectMapper = new ObjectMapper();
                List<ChuanyunBuildProject> bpList = objectMapper.convertValue(bizObject, new TypeReference<>() {
                });
                if (!bpList.isEmpty()) {
                    return bpList;
                }
            }
        }
        return null;
    }
}
