package com.galaxis.manatee.Test;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.dao.ChuanyunGroupProjectDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import com.galaxis.manatee.task.ChuanyunBasicDataScheduledTask;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;
import java.util.Objects;

@SpringBootTest
public class GroupProjectTest {

    @Autowired
    private ChuanyunBasicDataScheduledTask basicDataScheduledTask;

    @Autowired
    private ChuanYunManager chuanYunManager;

    @Autowired
    private ChuanyunGroupProjectDao chuanyunGroupProjectDao;

    @Test
    public void saveGroupProject() {
        basicDataScheduledTask.getGroupProjectManually();
    }

    @Test
    public void getGroupProject() {
        ObjectMapper objectMapper = new ObjectMapper();
        //从氚云查询数据
        var filter = Filter.instance(0, 20, true);
        ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
        try {
            chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunGroupProjectDO.SCHEMA_CODE, filter);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        if (!Objects.isNull(chuanyunFindAllResponse)) {
            //转化为POJO
            List<ChuanyunGroupProjectDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
            });
            //保存
            result.forEach(chuanyunGroupProjectDO -> {
                var tmpGroupProjectDO = chuanyunGroupProjectDao.findById(chuanyunGroupProjectDO.getObjectId());
                tmpGroupProjectDO.ifPresent(projectDO -> {
                    chuanyunGroupProjectDO.setIsCreate(projectDO.getIsCreate());
                    chuanyunGroupProjectDao.delete(tmpGroupProjectDO.get());
                });
                chuanyunGroupProjectDao.save(chuanyunGroupProjectDO);
            });
        }


    }

}
