package com.galaxis.manatee.Test.salaProjectTest;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunGroupProjectDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunSaleProjectDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunFindAllBizDTO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunSaveDTO;
import com.galaxis.manatee.entity.chuanyun.dto.Filter;
import com.galaxis.manatee.manager.ChuanYunManager;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

@Slf4j
@SpringBootTest
public class UpdateProjectName {

    private ChuanYunManager chuanYunManager;

    @Autowired
    public void setChuanYunManager(ChuanYunManager chuanYunManager) {
        this.chuanYunManager = chuanYunManager;
    }

    @Test
    void changeSaleName() {
        var objectMapper = new ObjectMapper();
        var start = 0;
        var totalCount = 0L;
        var flag = true;
        var pageSize = 200;
        List<String> m = List.of("F0000005_2,销售项目");

        while (flag) {

            //从氚云查询数据
            var filter = Filter.instance(start, start + pageSize, true, Filter.AND, m);
            ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
            try {
                chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunGroupProjectDO.SCHEMA_CODE, filter);
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }
            if (chuanyunFindAllResponse.getReturnData() == null) {
                flag = false;
                continue;
            }
            if (chuanyunFindAllResponse.getReturnData().getTotalCount() >= start + pageSize) {
                start += pageSize;
            } else {
                flag = false;
            }


            //转化为POJO
            List<ChuanyunGroupProjectDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
            });
            //获取项目总数
            result.forEach(chuanyunGroupProjectDO -> {
                try {
                    log.info("{}", chuanyunGroupProjectDO);
                    List<String> m2 = List.of("F0000034_2," + chuanyunGroupProjectDO.getProjectCode());
                    var filter2 = Filter.instance(0, 10, true, Filter.AND, m2);
                    ChuanyunFindAllBizDTO<Object> all = chuanYunManager.findAll(ChuanyunSaleProjectDO.SCHEMA_CODE, filter2);
                    if (all.getReturnData() == null) {
                        return;
                    }


                    //转化为POJO
                    List<ChuanyunSaleProjectDO> res = objectMapper.convertValue(all.getReturnData().getBizObjectArray(), new TypeReference<>() {
                    });

                    if (!res.isEmpty()) {
                        ChuanyunSaleProjectDO chuanyunSaleProjectDO = res.get(0);
                        GroupProjectSaleNameUpdateDTO groupProjectStateUpdateDTO = new GroupProjectSaleNameUpdateDTO();
                        groupProjectStateUpdateDTO.setProjectName(chuanyunSaleProjectDO.getProjectName());
                        String jsonStr = objectMapper.writeValueAsString(groupProjectStateUpdateDTO);
                        ChuanyunSaveDTO update = chuanYunManager.update(ChuanyunGroupProjectDO.SCHEMA_CODE, chuanyunGroupProjectDO.getObjectId(), jsonStr);
                        log.info("{}", update.getSuccessful());
                    }


                } catch (Exception e) {
                    e.printStackTrace();
                }
            });

        }
    }

    @Data
    static class GroupProjectSaleNameUpdateDTO {
        @JsonProperty("F0000003")
        private String projectName;
    }

    @Data
    static class GroupProjectUpdateDTO {
        @JsonProperty("F0000011")
        private String projectManager;
    }

    @Test
    void changeProjectManager() {
        var objectMapper = new ObjectMapper();
        var start = 0;
        var totalCount = 0L;
        var flag = true;
        var pageSize = 200;
        List<String> m = List.of("F0000005_2,销售项目", "F0000005_2,研发项目", "F0000005_2,管理项目");

        while (flag) {

            //从氚云查询数据
            var filter = Filter.instance(start, start + pageSize, true, Filter.OR, m);
            ChuanyunFindAllBizDTO<Object> chuanyunFindAllResponse = null;
            try {
                chuanyunFindAllResponse = chuanYunManager.findAll(ChuanyunGroupProjectDO.SCHEMA_CODE, filter);
            } catch (JsonProcessingException e) {
                e.printStackTrace();
            }
            if (chuanyunFindAllResponse.getReturnData() == null) {
                flag = false;
                continue;
            }
            if (chuanyunFindAllResponse.getReturnData().getTotalCount() >= start + pageSize) {
                start += pageSize;
            } else {
                flag = false;
            }


            //转化为POJO
            List<ChuanyunGroupProjectDO> result = objectMapper.convertValue(chuanyunFindAllResponse.getReturnData().getBizObjectArray(), new TypeReference<>() {
            });
            //获取项目总数
            result.forEach(chuanyunGroupProjectDO -> {
                try {
                    GroupProjectUpdateDTO groupProjectUpdateDTO = new GroupProjectUpdateDTO();
                    groupProjectUpdateDTO.setProjectManager(chuanyunGroupProjectDO.getProjectOwnerObject().getObjectId());
                    String jsonStr = objectMapper.writeValueAsString(groupProjectUpdateDTO);
                    ChuanyunSaveDTO update = chuanYunManager.update(ChuanyunGroupProjectDO.SCHEMA_CODE, chuanyunGroupProjectDO.getObjectId(), jsonStr);
                    log.info("{}", update.getSuccessful());

                } catch (Exception e) {
                    e.printStackTrace();
                }
            });

        }
    }
}
